/*
TASK: peb
LANG: C++
*/
#include <iostream>
#include <queue>
using namespace std;
struct moment{
    int x,y,z;
};
long long used[128][128][128];
void dfs(int i, int j, int k){
    used[i][j][k] = 1;
    queue <moment> q;
    moment t;
    t.x = i;
    t.y = j;
    t.z = k;
    q.push(t);
    while(!q.empty()){
        t = q.front();
        q.pop();
        i = t.x;
        j = t.y;
        k = t.z;
        if ( i != 0 && j != 0){
            if ( i >= j ){
                if (!used[i-j][j*2][k]){
                    used[i-j][j*2][k] = used[i][j][k] + 1;
                    moment cur;
                    cur.x = i - j;
                    cur.y = j * 2;
                    cur.z = k;
                    q.push(cur);
                }
            }
            else{
                if (!used[i*2][j-i][k]){
                    used[i*2][j-i][k] = used[i][j][k] + 1;
                    moment cur;
                    cur.x = i * 2;
                    cur.y = j - i;
                    cur.z = k;
                    q.push(cur);
                }
            }
        }
        if ( i != 0 && k != 0){
            if ( i >= k ){
                if (!used[i-k][j][k*2]){
                    used[i-k][j][k*2] = used[i][j][k] + 1;
                    moment cur;
                    cur.x = i - k;
                    cur.y = j ;
                    cur.z = k * 2;
                    q.push(cur);
                }
            }
            else{
                if (!used[i*2][j][k-i]){
                    used[i*2][j][k-i] = used[i][j][k] + 1;
                    moment cur;
                    cur.x = i * 2;
                    cur.y = j ;
                    cur.z = k - i;
                    q.push(cur);
                }
            }
        }
        if ( k != 0 && j != 0){
            if ( j >= k){
                if (!used[i][j-k][k*2]){
                    used[i][j - k][k*2] = used[i][j][k] + 1;
                    moment cur;
                    cur.x = i;
                    cur.y = j - k;
                    cur.z = k * 2;
                    q.push(cur);
                }
            }
            else{
                if (!used[i][j*2][k-j]){
                    used[i][j*2][k-j] = used[i][j][k] + 1;
                    moment cur;
                    cur.x = i;
                    cur.y = j * 2;
                    cur.z = k - j;
                    q.push(cur);
                }
            }
        }
    }
}  
int main(){
    int a,b,c;
    cin >> a >> b >> c;
    if ( ( a + b + c )%2){
        cout << -1 << endl;
        return 0;
    }
    dfs(a,b,c);
    if ( used[a+b+c][0][0] == 0 )
    used[a+b+c][0][0] = (1 << 30);
        if ( used[0][a+b+c][0] == 0 )
    used[0][a+b+c][0] = (1 << 30);
        if ( used[0][0][a+b+c] == 0 )
    used[0][0][a+b+c] = (1 << 30);
    int mn = min(used[a+b+c][0][0],min(used[0][0][a+b+c],used[0][a+b+c][0]));
    if ( mn == ( 1 << 30 )) mn = 0;
    cout << mn -1 << endl;      
}
